/*=============================================================================
  Copyright (c) YOUR_COPYRIGHT_MESSAGE_HERE

  File: PLUGNAME.h

  Author: YOU
  Date: DATE

  Description: 

=============================================================================*/
#define _MESSIAH_FULL_API			// All headers
#include <messiah_main.h>

#ifdef __cplusplus
	#include <vector>		// used by ObjectSelect
	#include <algorithm>	// for find and for_each
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////
// Handle Visibility	////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

#define HV_SHOW			0
#define	HV_HIDE			1
#define HV_TOGGLE		2
#define HV_KEY_EXISTS	3
#define HV_NO_KEY		4

#define HV_SELF			0
#define HV_SIBLINGS		1
#define HV_CHILDREN		2

typedef struct
{
	FXint		show;
	FXint		affects;
}HandleVisibility_state;

// Access Notification Information ////////////////////////////////////////////////////////////////

// Access Function
FX_ACCESSFUNC(HandleVisibility_access_func);

// Entry Functions
FX_ENTRYFUNC(HandleVisibility_entry_action);
FX_ENTRYFUNC(HandleVisibility_entry_interface);

// Requested Access Notification messages (some common ones provided)
static FXint64 HandleVisibility_action_an		= ACT_PROCESS|ACT_CREATE|ACT_LOAD|ACT_SAVE;
static FXint64 HandleVisibility_interface_an	= IN_CREATE;
////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////////////////
// MoveTowards	////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

FX_VAR( FXmodule, MoveTowards );

// Access Notification Information ////////////////////////////////////////////////////////////////

// Access Function
FX_ACCESSFUNC(MoveTowards_access_func);

// Entry Functions
FX_ENTRYFUNC(MoveTowards_entry_action);
FX_ENTRYFUNC(MoveTowards_entry_system);

// Requested Access Notification messages (some common ones provided)
static FXint64 MoveTowards_action_an	= ACT_PROCESS;
static FXint64 MoveTowards_system_an	= S_MODULE_INIT;
////////////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// Target
/////////////////////////////////////////////////////////////

typedef struct
{
	FXobject	target;
}Target_state;

// Target Access Function
// *************************************
FX_ACCESSFUNC(Target_access_func);

// Target Entry Function(s)
// *************************************

//     ACCESS_INTERFACE     //
static FXint64	Target_interface_an = IN_CREATE;
FX_ENTRYFUNC(	Target_entry_interface);

//     ACCESS_SYSTEM     //
static FXint64	Target_system_an = S_MODULE_INIT;
FX_ENTRYFUNC(	Target_entry_system);

//     ACCESS_ACTION     //
static FXint64	Target_action_an = ACT_CREATE|ACT_PROCESS|ACT_LOAD|ACT_SAVE;
FX_ENTRYFUNC(	Target_entry_action);

/////////////////////////////////////////////////////////////
// End Module Target
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// ObjectSelectDrag
/////////////////////////////////////////////////////////////

// ObjectSelectDrag Access Function
// *************************************
FX_ACCESSFUNC(ObjectSelectDrag_access_func);

// ObjectSelectDrag Entry Function(s)
// *************************************

//     ACCESS_SYSTEM     //
static FXint64	ObjectSelectDrag_system_an = S_MODULE_INIT;
FX_ENTRYFUNC(	ObjectSelectDrag_entry_system);

/////////////////////////////////////////////////////////////
// End Module ObjectSelectDrag
/////////////////////////////////////////////////////////////


