/*=============================================================================
  Copyright (c) YOUR_COPYRIGHT_MESSAGE_HERE

  File: HandleVisibility_entry_interface.h

  Author: YOU
  Date: DATE

  Description: { fill in with your module's ACCESS_INTERFACE handler, some common AN's are provided }

=============================================================================*/
#include "ActionExamples.h"


FX_CONCALLBACK(HandleVisibility_showPU_cb);
FX_CONCALLBACK(HandleVisibility_affectsPU_cb);

extern char * HandleVisibility_key;

FX_ENTRYFUNC(HandleVisibility_entry_interface)
// FXint f(FX_AccessInfo *ai, FXentity ID, FXint64 entry)
{
	//FXshader shader = (FXshader)ID;	// shader that triggered this notification
	//FXeffect effect = (FXeffect)ID;	// effect that triggered this notification
	FXobject object = (FXobject)ID;		// generic FXobject that triggered this notification
	HandleVisibility_state *state = NULL;		// state data variable

	switch( entry )
	{
	case IN_CREATE:	// Interface Created
		{
			FXcontrol	block, showPU, affectsPU;
			static FXchar *	showStrings[5] = { "Visible", "Hidden", "Toggle", "Key Exists", "No Key", NULL };
			static FXchar *	affectsStrings[4] = { "Self", "Siblings", "Children", NULL };

			block = fxCC_Block( "Handle Visibility Options", NULL, ACC_NONE, FX_NOFLAG );
			
			showPU = fxCC_PopupList( "Show Handle(s)", HandleVisibility_showPU_cb, ACC_VALUE|ACC_UPDATE, 
									  100, showStrings, FX_NOFLAG );
			fxConSetPos( showPU, 100, 10 );
			
			affectsPU = fxCC_PopupList( "Affects", HandleVisibility_affectsPU_cb, ACC_VALUE|ACC_UPDATE, 
										 100, affectsStrings, FX_NOFLAG );
			fxConSetPos( affectsPU, 100, 2*10 + CONTROL_HEIGHT );


		}// IN_CREATE
		break;
	}

	return ENTRY_OK;

}


FX_CONCALLBACK(HandleVisibility_showPU_cb)
//FX_CONCALLBACK(func)	FXint	func(FXcontrol ctl,  FXentity ctl_data, FX_Arg *arg, FXint64 entry)
{
	HandleVisibility_state *state = NULL;		// state data variable
	FXaction	action = ctl_data;

	if( !(state = fxDataGet( action, &HandleVisibility_key, 0 )) )
		return ENTRY_BREAK;

	switch( entry )
	{
	case ACC_UPDATE:
		{
			fxConSetInt( ctl, state->show );
		}
		break;

	case ACC_VALUE:
		{
			fxConGetInt( ctl, &(state->show) );
		}
		break;

	}

	return ENTRY_OK;
}

FX_CONCALLBACK(HandleVisibility_affectsPU_cb)
//FX_CONCALLBACK(func)	FXint	func(FXcontrol ctl,  FXentity ctl_data, FX_Arg *arg, FXint64 entry)
{
	HandleVisibility_state *state = NULL;		// state data variable
	FXaction	action = ctl_data;

	if( !(state = fxDataGet( action, &HandleVisibility_key, 0 )) )
		return ENTRY_BREAK;

	switch( entry )
	{
	case ACC_UPDATE:
		{
			fxConSetInt( ctl, state->affects );
		}
		break;

	case ACC_VALUE:
		{
			fxConGetInt( ctl, &(state->affects) );
		}
		break;

	}

	return ENTRY_OK;
}
