/*=============================================================================
  Copyright (c) YOUR_COPYRIGHT_MESSAGE_HERE

  File: MODNAME_access.h

  Author: pmG
  Date: 3/26/03

  Description: This file houses the access_func for one or more modules.
  The access_func defined here can handle all messages and will delegate them to 
  entry_funcs. Typically you will not need to modify anything in this file other 
  than text replacement for your specific module and plugin names.

=============================================================================*/
#include "PLUGNAME.h"

FX_ACCESSFUNC(MODNAME_access_func)
// FXint access_func(FX_AccessInfo *ai, FXentity ID, FXint level, FXint64 entry)
{
	switch( level )
	{
	case ACCESS_OBJECT:
		return MODNAME_entry_object( ai, ID, entry );

	case ACCESS_PROCESS:
		return MODNAME_entry_process( ai, ID, entry );

	case ACCESS_INTERFACE:
		return MODNAME_entry_interface( ai, ID, entry );

	case ACCESS_GENERAL:
		return MODNAME_entry_general( ai, ID, entry );

	case ACCESS_SYSTEM:
		return MODNAME_entry_system( ai, ID, entry );

	case ACCESS_EFFECT:
		return MODNAME_entry_effect( ai, ID, entry );

	case ACCESS_ARMATURE:
		return MODNAME_entry_armature( ai, ID, entry );

	case ACCESS_ACTION:
		return MODNAME_entry_action( ai, ID, entry );

	}

	return ENTRY_OK;

}