/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_tool_light.h
	Author:	Lyle Milton
	Date:	03/28/04

	------------------------------------------------------------



=============================================================================*/

#ifndef __MESSIAH_LIGHT
#define __MESSIAH_LIGHT

#ifndef __MESSIAH_HIDE_TYPES

	//Light types,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define	FX_LIGHTTYPE_DISTANT	0
	#define	FX_LIGHTTYPE_POINT		1
	#define	FX_LIGHTTYPE_SPOT		2
	#define	FX_LIGHTTYPE_SPHERE		3
	#define	FX_LIGHTTYPE_PANEL		4

	//fxLight,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define FX_LIGHTDATA_RENDER		(1<<31) //use this flag if you need to get light info in the context of the renderer


	//fxLightScan,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define FX_LIGHTSCAN_ACTIVEONLY	(1<<28)
	#define FX_LIGHTSCAN_NOLIGHT	(1<<29)
	#define FX_LIGHTSCAN_NOMASTER	(1<<30)
	#define FX_LIGHTSCAN_RENDER		FX_LIGHTDATA_RENDER


	//Callback for fxLightScan
	#define FX_LIGHTSCAN(f, dt, ed)	FXintf f(FXtool lightID, dt *ed)


#endif //__MESSIAH_HIDE_TYPES




FX_API(FXint, fxLightType)(FXtool lightID, FXint *type, FXint flags);

FX_API(FXint, fxLightIntensity)(FXtool lightID, FXdouble *intensity, FXint flags);

FX_API(FXint, fxLightDiffuse)(FXtool lightID, FXdouble *diffuse, FXint flags);

FX_API(FXint, fxLightSpecular)(FXtool lightID, FXdouble *specular, FXint flags);

FX_API(FXint, fxLightColor)(FXtool lightID, FXvecd color, FXint flags);

FX_API(FXint, fxLightSoftEdge)(FXtool lightID, FXdouble *soft_edge, FXint flags);

FX_API(FXint, fxLightConeAngle)(FXtool lightID, FXdouble *cone_angle, FXint flags);

FX_API(FXint, fxLightAspect)(FXtool lightID, FXdouble *aspect, FXint flags);

FX_API(FXint, fxLightLength)(FXtool lightID, FXdouble *length, FXint flags);

FX_API(FXint, fxLightFalloff)(FXtool lightID, FXdouble *falloff, FXint flags);

FX_API(FXint, fxLightFalloffType)(FXtool lightID, FXint *falloff_type, FXint flags);

FX_API(FXint, fxLightSize1)(FXtool lightID, FXdouble *size_1, FXint flags);

FX_API(FXint, fxLightSize2)(FXtool lightID, FXdouble *size_2, FXint flags);

FX_API(FXint, fxLightShadowType)(FXtool lightID, FXint *shadow_type, FXint flags);

FX_API(FXint, fxLightShadowQuality)(FXtool lightID, FXint *shadow_quality, FXint flags);

FX_API(FXint, fxLightVolumeShadowType)(FXtool lightID, FXint *vshadow_type, FXint flags);


FX_API(FXint, fxLightTypeSet)(FXtool lightID, FXint type, FXint flags);

FX_API(FXint, fxLightIntensitySet)(FXtool lightID, FXdouble intensity, FXint flags);

FX_API(FXint, fxLightDiffuseSet)(FXtool lightID, FXdouble diffuse, FXint flags);

FX_API(FXint, fxLightSpecularSet)(FXtool lightID, FXdouble specular, FXint flags);

FX_API(FXint, fxLightColorSet)(FXtool lightID, FXvecd color, FXint flags);

FX_API(FXint, fxLightSoftEdgeSet)(FXtool lightID, FXdouble soft_edge, FXint flags);

FX_API(FXint, fxLightConeAngleSet)(FXtool lightID, FXdouble cone_angle, FXint flags);

FX_API(FXint, fxLightAspectSet)(FXtool lightID, FXdouble aspect, FXint flags);

FX_API(FXint, fxLightLengthSet)(FXtool lightID, FXdouble length, FXint flags);

FX_API(FXint, fxLightFalloffSet)(FXtool lightID, FXdouble falloff, FXint flags);

FX_API(FXint, fxLightFalloffTypeSet)(FXtool lightID, FXint falloff_type, FXint flags);

FX_API(FXint, fxLightSize1Set)(FXtool lightID, FXdouble size_1, FXint flags);

FX_API(FXint, fxLightSize2Set)(FXtool lightID, FXdouble size_2, FXint flags);

FX_API(FXint, fxLightShadowTypeSet)(FXtool lightID, FXint shadow_type, FXint flags);

FX_API(FXint, fxLightShadowQualitySet)(FXtool lightID, FXint shadow_quality, FXint flags);

FX_API(FXint, fxLightVolumeShadowTypeSet)(FXtool lightID, FXint vshadow_type, FXint flags);


FX_API(FXint, fxLightActivate)(FXtool lightID, FXint flags);

FX_API(FXint, fxLightDeactivate)(FXtool lightID, FXint flags);

FX_API(FXint, fxLightIsActive)(FXtool lightID, FXint flags);


FX_API(FXint, fxLightScan)(FXtool lightID, FXint (*func)(FXtool, FXvoid*), FXvoid *data, FXint flags);



#define _MESSIAH_PTR_LIGHT	messiah_apicomponent = FX_APIFUNCS_TOOLTYPE;\
								FX_PTR(fxLightType);\
								FX_PTR(fxLightIntensity);\
								FX_PTR(fxLightDiffuse);\
								FX_PTR(fxLightSpecular);\
								FX_PTR(fxLightColor);\
								FX_PTR(fxLightSoftEdge);\
								FX_PTR(fxLightConeAngle);\
								FX_PTR(fxLightAspect);\
								FX_PTR(fxLightLength);\
								FX_PTR(fxLightFalloff);\
								FX_PTR(fxLightFalloffType);\
								FX_PTR(fxLightSize1);\
								FX_PTR(fxLightSize2);\
								FX_PTR(fxLightShadowType);\
								FX_PTR(fxLightShadowQuality);\
								FX_PTR(fxLightVolumeShadowType);\
								FX_PTR(fxLightTypeSet);\
								FX_PTR(fxLightIntensitySet);\
								FX_PTR(fxLightDiffuseSet);\
								FX_PTR(fxLightSpecularSet);\
								FX_PTR(fxLightColorSet);\
								FX_PTR(fxLightSoftEdgeSet);\
								FX_PTR(fxLightConeAngleSet);\
								FX_PTR(fxLightAspectSet);\
								FX_PTR(fxLightLengthSet);\
								FX_PTR(fxLightFalloffSet);\
								FX_PTR(fxLightFalloffTypeSet);\
								FX_PTR(fxLightSize1Set);\
								FX_PTR(fxLightSize2Set);\
								FX_PTR(fxLightShadowTypeSet);\
								FX_PTR(fxLightShadowQualitySet);\
								FX_PTR(fxLightVolumeShadowTypeSet);\
								FX_PTR(fxLightActivate);\
								FX_PTR(fxLightDeactivate);\
								FX_PTR(fxLightIsActive);\
								FX_PTR(fxLightScan)

#endif //__MESSIAH_LIGHT
