/*=============================================================================
	Copyright (c) 1999-2005 pmG Worldwide, LLC.

	File:	messiah_version.h
	Author:	Lyle Milton
	Date:	01/01/03

		last modified: 02/12/05 - LM

=============================================================================*/

#ifndef __MESSIAH_VERSION
#define __MESSIAH_VERSION

#define	_MESSIAH_PROGRAM_ANIMATE	1
#define	_MESSIAH_PROGRAM_STUDIO		2

#define _MESSIAH_API_VERSION		1
#define _MESSIAH_API_MAJORREV		_MESSIAH_API_VERSION
#define _MESSIAH_API_MINORREV		3


#define _PROGRAM_BITS		0x0000000f
#define _BUILD_BITS			0x00000ff0
#define _MINORREV_BITS		0x000ff000
#define _MAJORREV_BITS		0x00f00000



#define _GET_PROGRAM(v)		(((v) & _PROGRAM_BITS)  >>  0)
#define _GET_BUILD(v)		(((v) & _BUILD_BITS)    >>  4)
#define _GET_MINORREV(v)	(((v) & _MINORREV_BITS) >> 12)
#define _GET_MAJORREV(v)	(((v) & _MAJORREV_BITS) >> 20)

#define _SET_PROGRAM(v)		(((v) <<  0) &  _PROGRAM_BITS)
#define _SET_BUILD(v)		(((v) <<  4) &    _BUILD_BITS)
#define _SET_MINORREV(v)	(((v) << 12) & _MINORREV_BITS)
#define _SET_MAJORREV(v)	(((v) << 20) & _MAJORREV_BITS)


#define _SET_API_REV(ma, mi)				(_SET_MAJORREV(ma)|_SET_MINORREV(mi))
#define _SET_PROGRAM_REV(pr, ma, mi, bi)	(_SET_PROGRAM(pr)|_SET_MAJORREV(ma)|_SET_MINORREV(mi)|_SET_BUILD((FXint)(bi)))
#define _SET_PLUGIN_REV(ma, mi, bi)			(_SET_MAJORREV(ma)|_SET_MINORREV(mi)|_SET_BUILD((FXint)(bi)))


#endif //__MESSIAH_VERSION
