//isEffect flag
#define NOT_EFFECT	0
#define EFFECT		1

typedef struct FXtargetlist
{
	FXint targetcount;
	FXint *targetid;
	FXvoid *targetdata;

	//function pointers and size of data
	FXvoid (*datainit)(FXvoid *targetdata, FXint i, FXobject target); 
	FXvoid (*dataclean)(FXvoid *targetdata, FXint i, FXobject target);
	FXvoid (*datacopy)(FXvoid *from, FXint f, FXvoid *to, FXint t);
	size_t datasize;

	//id's used to when attaching data
	FXint idplugin;
	FXint iddata;
}FXtargetlist;

FX_API(FXtargetlist *, fxCreateTargetList)(FXint pluginid, FXint data_id, FXint isEffect, FXvoid *init, FXvoid *clean, FXvoid *copy, size_t datasize, FXvoid *customdata);
FX_API(FXint, fxDeleteTargetList)(FXtargetlist *tl);
FX_API(FXtargetlist *, fxFetchTargetList)(FXint pluginid, FXint data_id);

FX_API(FXint, fxTargetListAddTarget)(FXtargetlist *tl, FXint target_id);
FX_API(FXint, fxTargetListRemoveTarget)(FXtargetlist *tl, FXint target_id);
FX_API(FXint, fxTargetListReplaceTarget)(FXtargetlist *tl, FXint target_old, FXint target_new);
FX_API(FXint, fxTargetListSwitchTargetOrder)(FXtargetlist *tl, FXint target_1, FXint target_2);
FX_API(FXint, fxFindTargetOrder)(FXtargetlist *tl, FXint target_id);
FX_API(FXint, fxTargetListEffectUpdate)(FXtargetlist *tl);


#define _USEFUL_TARGET	fxCreateTargetList = fxGetAPIFunc("useful_CreateTargetList", FX_APIFUNCS_CUSTOM);\
						fxDeleteTargetList = fxGetAPIFunc("useful_DeleteTargetList", FX_APIFUNCS_CUSTOM);\
						fxFetchTargetList = fxGetAPIFunc("useful_FetchTargetList", FX_APIFUNCS_CUSTOM);\
						fxTargetListAddTarget = fxGetAPIFunc("useful_TargetListAddTarget", FX_APIFUNCS_CUSTOM);\
						fxTargetListRemoveTarget = fxGetAPIFunc("useful_TargetListRemoveTarget", FX_APIFUNCS_CUSTOM);\
						fxTargetListReplaceTarget = fxGetAPIFunc("useful_TargetListReplaceTarget", FX_APIFUNCS_CUSTOM);\
						fxTargetListSwitchTargetOrder = fxGetAPIFunc("useful_TargetListSwitchTargetOrder", FX_APIFUNCS_CUSTOM);\
						fxFindTargetOrder = fxGetAPIFunc("useful_FindTargetOrder", FX_APIFUNCS_CUSTOM);\
						fxTargetListEffectUpdate = fxGetAPIFunc("useful_TargetListEffectUpdate", FX_APIFUNCS_CUSTOM);