/*=============================================================================
  Copyright (c) Pekka Kytl

  File: useful_Triangulate.h

  Author: Pekka Kytl
  Date: 9:00 2008/12/15

  Description:
	Triangulation functions for messiah.

=============================================================================*/

typedef struct Triangle
{
	FXint index[3];
}Triangle;

typedef struct Poly
{
	FXint	 triangle_count;
	Triangle *triangle;
}Poly;

typedef struct Mesh
{
	FXint polygon_count;
	Poly *polygon;
}Mesh;

FX_API(Triangle *, fxTriangulatePolyId)(FXobject target, FXint polyID, FXint *tri_count, FXint meshdata);
FX_API(Mesh *, fxTriangulateTarget)(FXobject target,  FXint meshdata);
FX_API(FXvoid, fxFreeTriangle)(Triangle *triangle);
FX_API(FXvoid, fxFreeMesh)(Mesh *trimesh);

#define _USEFUL_TRI		fxTriangulatePolyId = fxGetAPIFunc("useful_TriangulatePolyId", FX_APIFUNCS_CUSTOM);\
						fxTriangulateTarget = fxGetAPIFunc("useful_TriangulateTarget", FX_APIFUNCS_CUSTOM);\
						fxFreeTriangle = fxGetAPIFunc("useful_FreeTriangle", FX_APIFUNCS_CUSTOM);\
						fxFreeMesh = fxGetAPIFunc("useful_FreeMesh", FX_APIFUNCS_CUSTOM);

